<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/memoryViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>

<body>
    <div class="container-fluid">
        <div class="row" style="margin-top: 5px; margin-bottom: 5px;">
            <div class="col">
                <button type="button" class="btn btn-primary" onclick='back()'>Back</button> 
            </div>
        </div>
        <div class="row">
            <div class="col">
                <label style="margin-top:5px ; margin-right: 5px; float:left;">hex/dec/string</label>
                <input id="target" class="form-control" id="input" style="float:left; width: 150px;   margin-right: 5px;" value="00000000" />
                <label style="float:left; margin-top:5px ; margin-right: 5px; ">from</label> 
                <input id="startAddress" class="form-control" id="input" style="float:left; width: 150px;  margin-right: 5px;" value="00000000" />
                <label style="float:left; margin-top:5px ; margin-right: 5px; ">to</label>
                <input id="endAddress" class="form-control" id="input" style="float:left; width: 150px;  margin-right: 5px;" value="00000000" />
                <button type="button" style="float:left;  margin-right: 5px;" class="btn btn-primary" onclick="search()">Search</button> 
                <button type="button" style="float:left;  margin-right: 5px;" class="btn btn-primary" onclick="cleartbody()">Clear</button> 
            </div>
        </div>

        <div class="row">
            <div class="col">
                <table class="table" id="cartGrid">
                    <thead>
                        <tr>
                            <th scope="col">Address</th>
                            <th scope="col">Bytes</th>
                            <th scope="col">String</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <script>
        const vscode = acquireVsCodeApi();
        parser = new DOMParser();
        var changed_address = [];

        function back(){
            var table = document.getElementById('cartGrid');

            var x = table.getElementsByTagName('tbody')[0].innerHTML;
            
         //   var row = document.getElementsByTagName('tobody')[0]
            vscode.postMessage({
                command: 'back',
                text: x,
                array: changed_address
            }); 
        }

        function search(){
            var t = document.getElementById("target").value;
            var st = document.getElementById("startAddress").value;
            var ed = document.getElementById("endAddress").value;

            var msg = t + "," + st + "," + ed
            vscode.postMessage({
                command: 'searchMemory',
                text: msg
            });  
        }

        function cleartbody(){
            $('#cartGrid tbody').empty();             
        }

        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
            case 'ddd':
                $('#cartGrid tbody').append(message.text);
                changed_address = message.array; 
                break;
            case 'initalAddressArray':
                    while(globalThis.changed_address.length){
                        globalThis.changed_address.pop();
                    }
            break;
            case 'lightTheUpdated':
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");      
                    let memNode = xmlDoc.getElementsByTagName("updateMemoryAddress")[0];  
               
                    for (let x = 0; x < memNode.childNodes.length; x++) {
                        let node = memNode.childNodes[x];

                        if (node.nodeType == Node.ELEMENT_NODE) {
                            var address = parseInt(node.firstChild.nodeValue,16);
                            globalThis.changed_address.push(address);     
                        }
                    }
                   
                break; 

            case 'updateSearch':              
                xmlDoc = parser.parseFromString(message.xml, "text/xml");               
                let MemoryNode = xmlDoc.getElementsByTagName("matchedMemory")[0];
                
                for (let x = 0; x < MemoryNode.childNodes.length; x++) {
                    let node = MemoryNode.childNodes[x];
                    if (node.nodeType == Node.ELEMENT_NODE) {
            
                        var temp = node.firstChild.nodeValue;
                        var dec_target = parseInt(node.getAttribute('target'));                             
                        var hex_target = dec_target.toString(16);
                
                        $('#cartGrid tbody').append("<tr>" + "<td>" + temp + "</td>" + "<td>" + "0x" + hex_target + "</td>" + "<td>" + "[" + dec_target + "]" + "</td>" +"</tr>");
                    }
                }
                break;
            }
        })
    </script>    
</body>

</html>